Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.drools.planner.core.localsearch.decider.acceptor.tabu
Class AbstractTabuAcceptor

    java.lang.Object
      org.drools.planner.core.localsearch.event.LocalSearchSolverPhaseLifecycleListenerAdapter
          org.drools.planner.core.localsearch.decider.acceptor.AbstractAcceptor
              org.drools.planner.core.localsearch.decider.acceptor.tabu.AbstractTabuAcceptor

All Implemented Interfaces:
  EventListener, Acceptor, LocalSearchSolverPhaseLifecycleListener

Direct Known Subclasses:
  MoveTabuAcceptor, PlanningEntityTabuAcceptor, PlanningValueTabuAcceptor, SolutionTabuAcceptor

    public abstract class AbstractTabuAcceptor

extends AbstractAcceptor

Abstract superclass for all Tabu Acceptors.

See Also:
  `Acceptor`

Field Summary
`protected boolean` | `aspirationEnabled`
`protected boolean` | `assertTabuHashCodeCorrectness`
`protected int` | `partialTabuSize`
`protected List<Object>` | `tabuSequenceList`
`protected int` | `tabuSize`
`protected Map<Object,Integer>` | `tabuToStepIndexMap`

Fields inherited from class org.drools.planner.core.localsearch.decider.acceptor.AbstractAcceptor
`logger`

Constructor Summary
`AbstractTabuAcceptor()`

Method Summary
`protected double` | `calculatePartialTabuAcceptChance(int partialTabuStepCount)`
`protected abstract Collection<? extends Object>` | `findNewTabu(LocalSearchStepScope localSearchStepScope)`
`protected abstract Collection<? extends Object>` | `findTabu(MoveScope moveScope)`
`int` | `getTabuSize()`
`boolean` | `isAccepted(MoveScope moveScope)`
`void` | `phaseStarted(LocalSearchSolverPhaseScope localSearchSolverPhaseScope)`
`void` | `setAspirationEnabled(boolean aspirationEnabled)`
`void` | `setAssertTabuHashCodeCorrectness(boolean assertTabuHashCodeCorrectness)`
`void` | `setPartialTabuSize(int partialTabuSize)`
`void` | `setTabuSize(int tabuSize)`
`void` | `stepTaken(LocalSearchStepScope localSearchStepScope)`

Methods inherited from class org.drools.planner.core.localsearch.event.LocalSearchSolverPhaseLifecycleListenerAdapter
`beforeDeciding, phaseEnded`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.drools.planner.core.localsearch.event.LocalSearchSolverPhaseLifecycleListener
`beforeDeciding, phaseEnded`

Field Detail

### tabuSize

    protected int tabuSize

### partialTabuSize

    protected int partialTabuSize

### aspirationEnabled

    protected boolean aspirationEnabled

### assertTabuHashCodeCorrectness

    protected boolean assertTabuHashCodeCorrectness

### tabuToStepIndexMap

    protected Map<Object,Integer> tabuToStepIndexMap

### tabuSequenceList

    protected List<Object> tabuSequenceList

Constructor Detail

### AbstractTabuAcceptor

    public AbstractTabuAcceptor()

Method Detail

### getTabuSize

    public int getTabuSize()

### setTabuSize

    public void setTabuSize(int tabuSize)

### setPartialTabuSize

    public void setPartialTabuSize(int partialTabuSize)

### setAspirationEnabled

    public void setAspirationEnabled(boolean aspirationEnabled)

### setAssertTabuHashCodeCorrectness

    public void setAssertTabuHashCodeCorrectness(boolean assertTabuHashCodeCorrectness)

### phaseStarted

    public void phaseStarted(LocalSearchSolverPhaseScope localSearchSolverPhaseScope)

  Specified by:
    `phaseStarted` in interface `LocalSearchSolverPhaseLifecycleListener`
  Overrides:
    `phaseStarted` in class `LocalSearchSolverPhaseLifecycleListenerAdapter`

### isAccepted

    public boolean isAccepted(MoveScope moveScope)

  Parameters:
    `moveScope` - not null
  Returns:
    true if accepted

### calculatePartialTabuAcceptChance

    protected double calculatePartialTabuAcceptChance(int partialTabuStepCount)

  Parameters:
    `partialTabuStepCount` - 0 < partialTabuStepCount <= partialTabuSize
  Returns:
    0.0 < acceptChance < 1.0

### stepTaken

    public void stepTaken(LocalSearchStepScope localSearchStepScope)

  Specified by:
    `stepTaken` in interface `LocalSearchSolverPhaseLifecycleListener`
  Overrides:
    `stepTaken` in class `LocalSearchSolverPhaseLifecycleListenerAdapter`

### findTabu

    protected abstract Collection<? extends Object> findTabu(MoveScope moveScope)

### findNewTabu

    protected abstract Collection<? extends Object> findNewTabu(LocalSearchStepScope localSearchStepScope)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 JBoss by Red Hat. All Rights Reserved.